package ac.essex.gp.multiclass;

import java.util.Vector;

/**
 * Holds data about the results of a multiclass experiment.
*
* @author Olly Oechsle, University of Essex, Date: 09-Feb-2007
* @version 1.0
*/
public class ClassResults {

    public Vector<ClassResult> classes;

    public ClassResults() {
        classes = new Vector<ClassResult>(10);
    }

    public void addClass(String name, int classID)  {
        classes.add(new ClassResult(name, classID));
    }

    public void addHit(int classID) {
        ClassResult c = getClassResult(classID);
        if (c != null) {
            c.registerHit();
        }
    }

    public void addMiss(int classID) {
        ClassResult c = getClassResult(classID);
        if (c != null) {
            c.registerMiss();
        }
    }

    public ClassResult getClassResult(int classID) {
        for (int i = 0; i < classes.size(); i++) {
            ClassResult classResult = classes.elementAt(i);
            if (classResult.classID == classID) return classResult;
        }
        return null;
    }

}
