package ac.essex.gp.nodes.imaging.texture;

import ac.essex.gp.params.NodeConstraints;
import ac.essex.gp.params.RangeTypes;
import ac.essex.gp.problems.DataStack;
import ac.essex.gp.tree.Terminal;

/**
 * Returns the result of the horizontal sobel operation on the image
 *
 * @author Olly Oechsle, University of Essex, Date: 15-Feb-2007
 * @version 1.0
 */
public class HorizontalSobel extends Terminal {

    public int[] getReturnTypes() {
        return new int[]{NodeConstraints.NUMBER, NodeConstraints.INTEGER, NodeConstraints.RANGE255, NodeConstraints.FEATURE};
    }


    public double execute(DataStack data) {
        data.usesImaging = true;        
        data.value = data.getImage().getHorizontalSobel(data.x, data.y);
        return debugger == null? data.value : debugger.record(data.value);
    }

    public String toJava() {
        return "image.getHorizontalSobel(x, y)";
    }

    public String getShortName() {
        return "HS";
    }

}
