package ac.essex.gp.nodes.imaging.texture3;

import ac.essex.gp.tree.Terminal;
import ac.essex.gp.params.NodeConstraints;
import ac.essex.gp.params.RangeTypes;
import ac.essex.gp.problems.DataStack;
import ac.essex.ooechs.imaging.commons.ColourChannels;

/**
 * Gets the average red value across a window of pixels.
 *
 * @author Olly Oechsle, University of Essex, Date: 07-Mar-2008
 * @version 1.0
 */
public class GreenStdDev extends Terminal {

    public int[] getReturnTypes() {
        return new int[]{NodeConstraints.NUMBER, NodeConstraints.FLOATING_POINT_NUMBER, NodeConstraints.FEATURE};
    }
    public double execute(DataStack data) {
        data.usesImaging = true;
        data.value = data.getImage().get3x3Stats(data.x, data.y, ColourChannels.GREEN).getStandardDeviation();
        return debugger == null? data.value : debugger.record(data.value);
    }

    public String toJava() {
        return "image.get3x3Stats(x, y, ColourChannels.GREEN).getStandardDeviation()";
    }

    public String getShortName() {
        return "Gsd";
    }

}
