package ac.essex.gp.nodes.math;

import ac.essex.gp.tree.Node;
import ac.essex.gp.params.NodeConstraints;
import ac.essex.gp.problems.DataStack;

/**
 * Signum Function tells you the sign of the function
 *
 * @author Olly Oechsle, University of Essex, Date: 02-Nov-2007
 * @version 1.0
 */
public class Signum extends Node {

    public Signum() {
        super(1);
    }

    public int[] getReturnTypes() {
        return new int[]{NodeConstraints.NUMBER, NodeConstraints.INTEGER};
    }

    public int getChildType(int index) {
        return NodeConstraints.NUMBER;
    }

    public double execute(DataStack data) {
        data.value = Math.signum(child[0].execute(data));
        return debugger == null? data.value : debugger.record(data.value);
    }

    public String toJava() {
        return "Math.signum(" + child[0].getName() + ")";
    }

    public String getShortName() {
        return "signum";
    }

}
